#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=_dispo_icones.ico
#AutoIt3Wrapper_outfile=_dispo_icones.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Comment=Sauvegarde restauration de la disposition des icones sur le bureau.
#AutoIt3Wrapper_Res_Description=Sauvegarde restauration de la disposition des icones sur le bureau.
#AutoIt3Wrapper_Res_Fileversion=1.3.0.0
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=p
#AutoIt3Wrapper_Res_SaveSource=y
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.0
 Author:         Fred39
;~ frederic.lamy@ac-besancon.fr
 Script Function:      Sauvegarde et restauration de la disposition des icones sur le bureau dans un environneemnt scribe
 Script adapt de celui de "JamesBrooks" iconmap layout
 http://www.autoitscript.com/forum/topic/52575-iconmap/page__p__397684#entry397684


#ce ----------------------------------------------------------------------------
#include <GuiListView.au3>

; Paramtres d'appel du script
    Switch $CmdLine[0]
        Case 2
            $sMode = ($CmdLine[1]); /SAVE or /RESTORE
            $sINI = StringReplace($CmdLine[2],"/","",1); le fichier ini (on enlve un ventuel "/" avant le second paramtre)
        Case Else
            msgbox (0,@ScriptName, "Erreur :  le programme doit tre appel avec les paramtres suivants"&@CRLF& @CRLF & @ScriptName & " /save fichier.ini"&@CRLF & @ScriptName & " /restore fichier.ini")
		Exit
	EndSwitch


; Dfinition du flag indiquant qu'aucune sauvegarde de disposition icone n'a t faite
$nosINI = $sINI&".no.txt"

; rcupration du handle du bureau
$H_desktop = ControlGetHandle("[CLASS:Progman]", "", "SysListView321")

; Save ou Restore?
Switch StringUpper($sMode)
	Case "/SAVE"
	; suppression du flag 	$nosINI
	if FileExists ($nosINI) then FileDelete ($nosINI)
    ; suppression de l'ancienne section dans le fichier ini et on controle si on a les droits d'criture pour le fichier ini
	if FileExists ($sINI) Then
		$Flag_write_ini=FileDelete($sINI)
		if $Flag_write_ini=0 then
			MsgBox(0,@ScriptName, "Erreur: impossible d'crire le fichier :" & @CRLF & $sINI & @CRLF & @CRLF & "Veuillez vrifier les droits sur le rpertoire concern.")
			Exit; en cas d'erreur on quitte
		EndIf
	EndIf
    ; liste des lments, et sauvegarde  de leur position dans le fichier ini.
        For $nIdx = 0 To _GUICtrlListView_GetItemCount($H_desktop) - 1
            $sIconText = _GUICtrlListView_GetItemText($H_desktop, $nIdx)
            $aPos = _GUICtrlListView_GetItemPosition($H_desktop, $nIdx)
            If @error Then MsgBox(32, StringTrimRight(@ScriptName, 4), "Il y a eu une erreur lors de la lecture la position de l'icne " & $sIconText)
      $Flag_write_ini=IniWrite($sINI, "Icones", $sIconText, Round ($aPos[0]*100/@DesktopWidth) & ":" & Round($aPos[1]*100/@DesktopHeight))
        Next
        Beep(1500, 100)
        Beep(1000, 100)
        Beep(500, 100)
		if $Flag_write_ini=0 then
			MsgBox(0,@ScriptName, "Erreur: impossible d'crire le fichier :" & @CRLF & $sINI & @CRLF & @CRLF & "Veuillez vrifier les droits sur le rpertoire concern.")
		Else
			MsgBox(0,@ScriptName, "La disposition des icnes a t sauvegarde.")
		EndIf


    Case "/RESTORE"
		if FileExists($sINI) then  ; on test si le fichier ini existe
		; liste des lments, et remise en position  partir du fichier ini.
			For $nIdx = 0 To _GUICtrlListView_GetItemCount($H_desktop) - 1
				$sIconText = _GUICtrlListView_GetItemText($H_desktop, $nIdx)
				$aPos = StringSplit(IniRead($sINI, "Icones", $sIconText, "0:0"), ":")
				If $aPos[0] <> 2 Then
					MsgBox(0, StringTrimRight(@ScriptName, 4), "Erreur: Les coordonnes sont invalides pour l'icne: " & @LF & @LF & $sIconText)
					Exit
				EndIf
				; On ne dplace l'icone si et seulement si il a des coordonnes.
				; on dplace les icones une premire fois  cot de l'ecran  pour viter les problmes de chevauchement
				If String($aPos[1]&":"&$aPos[2])<>"0:0" Then  _GUICtrlListView_SetItemPosition($H_desktop, $nIdx, Round($aPos[1]*@DesktopWidth/100+@DesktopWidth), Round($aPos[2]*@DesktopHeight/100))
			Next

			For $nIdx = 0 To _GUICtrlListView_GetItemCount($H_desktop) - 1
				$sIconText = _GUICtrlListView_GetItemText($H_desktop, $nIdx)
				$aPos = StringSplit(IniRead($sINI, "Icones", $sIconText, "0:0"), ":")
				If $aPos[0] <> 2 Then
					MsgBox(0, StringTrimRight(@ScriptName, 4), "Erreur: Les coordonnes sont invalides pour l'icne: " & @LF & @LF & $sIconText)
					Exit
				EndIf
				If String($aPos[1]&":"&$aPos[2])<>"0:0" Then _GUICtrlListView_SetItemPosition($H_desktop, $nIdx, Round($aPos[1]*@DesktopWidth/100), Round($aPos[2]*@DesktopHeight/100))
			Next

		Else
			if Not FileExists	($nosINI) Then
				FileWrite ($nosINI, "Il n'y a pas de fichier "&$sINI)
			EndIf
		EndIf
    Case Else
        msgbox (0,@ScriptName, "Erreur :  le programme doit tre appel avec les paramtres suivants"&@CRLF& @CRLF & @ScriptName & " /save fichier.ini"&@CRLF & @ScriptName & " /restore fichier.ini")
EndSwitch
